#include <boost/signals2.hpp>   /// HEADER ONLY LIBRARY

#include <iostream>
#include <functional>

/// say, we have a signal that returns a value

namespace
{

void foo(int x, int y)
{
    std::cout << "foo : " << x << "," << y << std::endl;
}

class Test
{
public:
    Test() = default;

    void operator()(int x, int y)
    {
        std::cout << "Test : " << x << "," << y << std::endl;
    }
};

class Yoyo
{
public:
    Yoyo() = default;

    void doSomething(int x, int y)
    {
        std::cout << "Yoyo : " << x << "," << y << std::endl;
    }
};

} // namespace

int main()
{
    boost::signals2::signal<void (int, int)> sig;

    sig.connect(foo);
    sig.connect([](int x, int y){std::cout << "lambda : " << x << "," << y<< std::endl;});
    Test test;
    sig.connect(test);

    Yoyo yoyo;
    sig.connect(std::bind(&Yoyo::doSomething, yoyo, std::placeholders::_1, std::placeholders::_2));

    sig(242, 101);
}
