#include <boost/signals2.hpp>   /// HEADER ONLY LIBRARY

#include <iostream>
#include <functional>

/// events, observation ==> more general : SIGNAL ==> SLOT
///
///     a signal sends information to one or more interested slots
///         ==> there is as such a connection between the signal and the slot


/// the signal expect slots of a given signature, this signature is a template type parameter

/// triggering the signal to notify (to signal) are the slots ==> function call () on the signal

namespace
{

void foo()
{
    std::cout << "foo" << std::endl;
}

void bar()
{
    std::cout << "bar" << std::endl;
}

class Test
{
public:
    Test() = default;

    void operator()()
    {
        std::cout << "Test" << std::endl;
    }
};

class Yoyo
{
public:
    Yoyo() = default;

    void doSomething()
    {
        std::cout << "Yoyo" << std::endl;
    }
};

} // namespace

int main()
{
    boost::signals2::signal<void ()> sig;

    sig.connect(foo);
    sig.connect(bar);
    sig.connect([](){std::cout << "lambda" << std::endl;});
    Test test;
    sig.connect(test);

    Yoyo yoyo;
    sig.connect(std::bind(&Yoyo::doSomething, yoyo));

    sig();
}
