#include <boost/signals2.hpp>   /// HEADER ONLY LIBRARY

#include <iostream>

/// signals are executed in the order they were added

/// order can be influenced by extra argument during connect

/// ==> groups of (withing group order of addition)

///  connects without order specification go after all "with specification" (by default, can also be tailored)

namespace
{

void foo()
{
    std::cout << "foo" << std::endl;
}

void bar()
{
    std::cout << "bar" << std::endl;
}

void test()
{
    std::cout << "test" << std::endl;
}

void yoyo()
{
    std::cout << "yoyo" << std::endl;
}

void hoho()
{
    std::cout << "hoho" << std::endl;
}

void momo()
{
    std::cout << "momo" << std::endl;
}

void defaultUnspecified()
{
    boost::signals2::signal<void ()> sig;

    sig.connect(hoho);

    sig.connect(0, foo);
    sig.connect(1, bar);

    sig.connect(momo);

    sig.connect(0, test);

    sig.connect(yoyo);

    sig();
}

void customizedUnspecified()
{
    boost::signals2::signal<void ()> sig;

    sig.connect(hoho, boost::signals2::at_front);

    sig.connect(0, foo);
    sig.connect(1, bar);

    sig.connect(momo, boost::signals2::at_front);

    sig.connect(0, test);

    sig.connect(yoyo, boost::signals2::at_back);

    sig();
}

} // namespace

int main()
{
    defaultUnspecified();

    std::cout << std::endl << std::endl;

    customizedUnspecified();
}
