#include <boost/signals2.hpp>   /// HEADER ONLY LIBRARY

#include <iostream>

namespace
{

void foo()
{
    std::cout << "foo" << std::endl;
}

void bar()
{
    std::cout << "bar" << std::endl;
}

} // namespace

int main()
{
    boost::signals2::signal<void ()> sig;

    std::cout << "are there no slots connected : " << std::boolalpha << sig.empty() << std::endl;
    std::cout << "Number slots connected : " << sig.num_slots() << std::endl;

    sig.connect(foo);
    sig.connect(bar);

    std::cout << "Number slots connected : " << sig.num_slots() << std::endl;

    sig.disconnect(foo);

    std::cout << "Number slots connected : " << sig.num_slots() << std::endl;

    sig.connect(bar);
    std::cout << "Number slots connected : " << sig.num_slots() << std::endl;
    sig();
}
